express = require "express"

dk.plugin "server", ->
  mod = {}
  portNumber = 8765
  server = express.createServer()

  # Middleware to change any requests with method 'del' to 'DELETE'
  # Sammy.js delete forms use 'del' for some reason, so this makes it work
  treatDelAsDELETE = (req, res, next) ->
    method = req.body["_method"] if req.body
    if method && method.toLowerCase() == "del"
      req.body._method = "DELETE"
    next()

  # Default middleware
  server.use express.favicon()
  server.use express.bodyParser()
  server.use treatDelAsDELETE
  server.use express.methodOverride()

  # Proxy methods to Express
  [ "get", "post", "put", "del", "use",
    "listeners", "removeAllListeners",
    "addListener", "removeListener", "on"].forEach (method) ->
      mod[method] = ->
        server[method].apply(server, arguments)

  mod.config = (opts) ->
    portNumber = opts.port unless opts.port == undefined # null means don't run server

  mod.run = ->
    if portNumber
      console.log "Running DrumKit at http://localhost:#{portNumber}"
      server.listen portNumber

  return mod
